'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _requiredOptions2 = require('./util/requiredOptions');

var _requiredOptions3 = _interopRequireDefault(_requiredOptions2);

var _readJsonDir = require('./util/readJsonDir');

var _readJsonDir2 = _interopRequireDefault(_readJsonDir);

var _constants = require('./util/constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var debug = require('./util/debug')('read');

exports.default = function (options, cb) {
  var _requiredOptions = (0, _requiredOptions3.default)(options, ['dir', 'user']);

  var dir = _requiredOptions.dir;
  var user = _requiredOptions.user;


  var userDir = _path2.default.join(dir, user, _constants.JSON_DIRNAME);
  debug('Reading directory ' + userDir);

  (0, _readJsonDir2.default)({ dir: userDir, comparator: function comparator(item) {
      return Number(item.created_time) * -1;
    } }, cb);
};

module.exports = exports['default'];